Index: orderView.fo.ftl
===================================================================
--- orderView.fo.ftl	(revision 6675)
+++ orderView.fo.ftl	(working copy)
@@ -26,10 +26,10 @@
 <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">
     <fo:layout-master-set>
         <fo:simple-page-master master-name="main-page"
-            margin-top="1in" margin-bottom="1in"
-            margin-left="1in" margin-right="1in">
-          <fo:region-body margin-top="3.5in" margin-bottom="1in"/>  <#-- main body -->
-            <fo:region-after extent="1in"/>  <#-- a footer -->
+            margin-top="0.6in" margin-bottom="0.6in"
+            margin-left="0.6in" margin-right="0.6in">
+          <fo:region-body margin-top="3.5in" margin-bottom="0.5in"/>  <#-- main body -->
+            <fo:region-after extent="0.5in"/>  <#-- a footer -->
             <fo:region-before extent="3.5in"/>  <#-- a header -->
         </fo:simple-page-master>
   </fo:layout-master-set>
@@ -38,14 +38,50 @@
        <#-- the region-before and -after must be declared as fo:static-content and before the fo:flow.  only 1 fo:flow per
             fo:page-sequence -->
        <fo:static-content flow-name="xsl-region-before">
-         <#-- a nest of tables to put company information on left and invoice information on the right -->
+       <#-- a nest of tables to put company information on left and invoice information on the right -->
         <fo:table>
            <fo:table-column column-width="3.5in"/>
            <fo:table-column column-width="3in"/>
             <fo:table-body>
               <fo:table-row>
                 <fo:table-cell>
-                   ${screens.render("component://order/widget/ordermgr/OrderPrintForms.xml#CompanyLogo")}
+                  <fo:table>
+                    <fo:table-column column-width="3.5in"/>
+                    <fo:table-body>
+                      <fo:table-row>
+                        <fo:table-cell>
+                          <fo:block font-size="18pt" font-family="sans-serif" font-weight="bold" font-style="italic"> 
+                          BioWaves, LLC.
+                          </fo:block>
+                        </fo:table-cell>
+                      </fo:table-row>
+                      <fo:table-row>                    
+                        <fo:table-cell>
+                          <fo:block>14150 NE 20th St. Suite F1</fo:block>
+                        </fo:table-cell>
+                      </fo:table-row>
+                      <fo:table-row>                    
+                        <fo:table-cell>
+                           <fo:block>Bellevue, WA 98007</fo:block>
+                        </fo:table-cell>
+                      </fo:table-row>
+                      <fo:table-row>                    
+                        <fo:table-cell>
+                          <fo:block>800-734-3588 425-895-0050</fo:block>
+                        </fo:table-cell>
+                      </fo:table-row>
+                      <fo:table-row>                    
+                        <fo:table-cell>
+                          <fo:block>www.BioWaves.com</fo:block>
+                        </fo:table-cell>
+                      </fo:table-row>
+                      <fo:table-row>                    
+                        <fo:table-cell>
+                          <fo:block>Shop@BioWaves.com</fo:block>
+                        </fo:table-cell>
+                      </fo:table-row>
+                    </fo:table-body>
+                  </fo:table>
                 </fo:table-cell>
                 <fo:table-cell>
                   <fo:table>
@@ -164,17 +200,19 @@
        <#-- this part is the footer.  Use it for standard boilerplate text. -->
        <fo:static-content flow-name="xsl-region-after">
 <#if orderHeader.getString("orderTypeId") == "SALES_ORDER">
-           <fo:block font-size="14pt" font-weight="bold" text-align="center">THANK YOU FOR YOUR PATRONAGE!</fo:block>
-           <fo:block font-size="8pt" white-space-collapse="false">
-Here is a good place to put policies and return information.
+           <fo:block font-size="12pt" font-weight="bold" 
+text-align="center">Thank you for Shopping @ BioWaves.com!</fo:block>
+           <fo:block font-size="10pt" text-align="center">
+Please come again soon.
 </fo:block>
 <#elseif orderHeader.getString("orderTypeId") == "PURCHASE_ORDER">
-           <fo:block font-size="8pt" white-space-collapse="false">
-Here is a good place to put boilerplate terms and conditions for a purchase order.
+           <fo:block font-size="11pt" font-weight="bold" text-align="center">
+Please let us know if we can be of any further assistance.
 </fo:block>
 </#if>
            <#-- displays page number.  "theEnd" is an id of a fo:block at the very end -->    
-           <fo:block font-size="10pt" text-align="center">Page <fo:page-number/> of <fo:page-number-citation ref-id="theEnd"/></fo:block>
+           <fo:block font-size="10pt" text-align="center">Page 
+<fo:page-number/> of <fo:page-number-citation ref-id="theEnd"/></fo:block>
        </fo:static-content>
        <#-- end of footer -->
        