Index: /ofbiz/applications/product/script/org/ofbiz/product/product/ProductUomFormulas.xml
===================================================================
--- /ofbiz/applications/product/script/org/ofbiz/product/product/ProductUomFormulas.xml	(revision 454206)
+++ /ofbiz/applications/product/script/org/ofbiz/product/product/ProductUomFormulas.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: $
 
 Copyright 2001-2006 The Apache Software Foundation
 
Index: /ofbiz/applications/product/script/org/ofbiz/product/product/CustomerDigitalDownloadServices.xml
===================================================================
--- /ofbiz/applications/product/script/org/ofbiz/product/product/CustomerDigitalDownloadServices.xml	(revision 454206)
+++ /ofbiz/applications/product/script/org/ofbiz/product/product/CustomerDigitalDownloadServices.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: $
 
 Copyright 2006-2006 The Apache Software Foundation
 
Index: /ofbiz/applications/product/script/org/ofbiz/product/subscription/SubscriptionServices.xml
===================================================================
--- /ofbiz/applications/product/script/org/ofbiz/product/subscription/SubscriptionServices.xml	(revision 454206)
+++ /ofbiz/applications/product/script/org/ofbiz/product/subscription/SubscriptionServices.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: $
 
 Copyright 2001-2006 The Apache Software Foundation
 
Index: /ofbiz/applications/product/script/org/ofbiz/product/cost/CostServices.xml
===================================================================
--- /ofbiz/applications/product/script/org/ofbiz/product/cost/CostServices.xml	(revision 454206)
+++ /ofbiz/applications/product/script/org/ofbiz/product/cost/CostServices.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: $
 
 Copyright 2001-2006 The Apache Software Foundation
 
Index: /ofbiz/applications/product/script/org/ofbiz/product/inventory/InventoryIssueServices.xml
===================================================================
--- /ofbiz/applications/product/script/org/ofbiz/product/inventory/InventoryIssueServices.xml	(revision 454206)
+++ /ofbiz/applications/product/script/org/ofbiz/product/inventory/InventoryIssueServices.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: InventoryIssueServices.xml 7023 2006-03-20 14:11:03Z jacopo $
 
 Copyright 2001-2006 The Apache Software Foundation
 
Index: /ofbiz/applications/product/config/ProductUiLabels_fr.properties
===================================================================
--- /ofbiz/applications/product/config/ProductUiLabels_fr.properties	(revision 454206)
+++ /ofbiz/applications/product/config/ProductUiLabels_fr.properties	(working copy)
@@ -1,5 +1,4 @@
 #####################################################################
-# $Id: ProductUiLabels_fr.properties 7741 2006-06-04 07:23:28Z jacopo $
 #
 # Copyright 2001-2006 The Apache Software Foundation
 #
Index: /ofbiz/applications/product/config/prodsearch.properties
===================================================================
--- /ofbiz/applications/product/config/prodsearch.properties	(revision 454206)
+++ /ofbiz/applications/product/config/prodsearch.properties	(working copy)
@@ -16,7 +16,6 @@
 #####################################################################
 ####
 # OFBiz Search Settings
-# $Id: prodsearch.properties 3688 2004-10-15 01:28:10Z jonesde $
 ####
 
 # The stop word bags contain words to be removed from search keyword list
Index: /ofbiz/applications/product/ofbiz-component.xml
===================================================================
--- /ofbiz/applications/product/ofbiz-component.xml	(revision 454206)
+++ /ofbiz/applications/product/ofbiz-component.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: ofbiz-component.xml 7385 2006-04-23 15:00:45Z jonesde $
 
 Copyright 2003-2006 The Apache Software Foundation
 
Index: /ofbiz/applications/accounting/config/payment.properties
===================================================================
--- /ofbiz/applications/accounting/config/payment.properties	(revision 454206)
+++ /ofbiz/applications/accounting/config/payment.properties	(working copy)
@@ -15,7 +15,6 @@
 #####################################################################
 ####
 # Payment Processor Configuration File
-# $Id: payment.properties 7899 2006-06-29 00:56:06Z sichen $
 ####
 
 ############################################
Index: /ofbiz/applications/order/src/org/ofbiz/order/finaccount/FinAccountHelper.java
===================================================================
--- /ofbiz/applications/order/src/org/ofbiz/order/finaccount/FinAccountHelper.java	(revision 454206)
+++ /ofbiz/applications/order/src/org/ofbiz/order/finaccount/FinAccountHelper.java	(working copy)
@@ -39,7 +39,6 @@
 
 /**
  * A package of methods for improving efficiency of financial accounts services
- * @author sichen
  *
  */
 public class FinAccountHelper {
Index: /ofbiz/framework/example/webapp/example/WEB-INF/web.xml
===================================================================
--- /ofbiz/framework/example/webapp/example/WEB-INF/web.xml	(revision 454206)
+++ /ofbiz/framework/example/webapp/example/WEB-INF/web.xml	(working copy)
@@ -1,7 +1,6 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE web-app PUBLIC "-//Sun Microsystems, Inc.//DTD Web Application 2.3//EN" "http://java.sun.com/dtd/web-app_2_3.dtd">
 <!--
-$Id: web.xml 7423 2006-04-26 22:36:00Z jonesde $
 
 Copyright 2001-2006 The Apache Software Foundation
 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/synchronization/EntitySyncServices.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/synchronization/EntitySyncServices.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/synchronization/EntitySyncServices.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntitySyncServices.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2001-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/synchronization/EntitySyncContext.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/synchronization/EntitySyncContext.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/synchronization/EntitySyncContext.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntitySyncContext.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2001-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/cache/EntityCacheServices.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/cache/EntityCacheServices.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/cache/EntityCacheServices.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityCacheServices.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2001-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/EntityServiceFactory.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/EntityServiceFactory.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/EntityServiceFactory.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityServiceFactory.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2002-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaAction.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaAction.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaAction.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityEcaAction.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2002-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaUtil.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaUtil.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaUtil.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityEcaUtil.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2002-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaException.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaException.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaException.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityEcaException.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2003-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaCondition.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaCondition.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaCondition.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityEcaCondition.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2002-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/DelegatorEcaHandler.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/DelegatorEcaHandler.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/DelegatorEcaHandler.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: DelegatorEcaHandler.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2003-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaRule.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaRule.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/eca/EntityEcaRule.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityEcaRule.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2002-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/permission/EntityPermissionChecker.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/permission/EntityPermissionChecker.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/permission/EntityPermissionChecker.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityPermissionChecker.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2001-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/data/EntityDataLoadContainer.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/data/EntityDataLoadContainer.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/data/EntityDataLoadContainer.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityDataLoadContainer.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2001-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/entityext/src/org/ofbiz/entityext/data/EntityDataServices.java
===================================================================
--- /ofbiz/framework/entityext/src/org/ofbiz/entityext/data/EntityDataServices.java	(revision 454206)
+++ /ofbiz/framework/entityext/src/org/ofbiz/entityext/data/EntityDataServices.java	(working copy)
@@ -1,5 +1,4 @@
 /*
- * $Id: EntityDataServices.java 7425 2006-04-26 23:04:59Z jonesde $
  *
  * Copyright 2001-2006 The Apache Software Foundation
  * 
Index: /ofbiz/framework/webtools/widget/WebToolsMenus.xml
===================================================================
--- /ofbiz/framework/webtools/widget/WebToolsMenus.xml	(revision 454206)
+++ /ofbiz/framework/webtools/widget/WebToolsMenus.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: $
 
 Copyright 2001-2006 The Apache Software Foundation
 
Index: /ofbiz/framework/webtools/widget/EntityScreens.xml
===================================================================
--- /ofbiz/framework/webtools/widget/EntityScreens.xml	(revision 454206)
+++ /ofbiz/framework/webtools/widget/EntityScreens.xml	(working copy)
@@ -1,6 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-$Id: EntityScreens.xml 7747 2006-06-06 23:37:04Z jonesde $
 
 Copyright 2004-2006 The Apache Software Foundation
 
Index: /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/AbstractCursorHandler.java
===================================================================
--- /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/AbstractCursorHandler.java	(revision 454206)
+++ /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/AbstractCursorHandler.java	(working copy)
@@ -21,11 +21,6 @@
 import java.lang.reflect.Method;
 import java.lang.reflect.Proxy;
 
-/**
- *
- * @version    $Rev$
- * @since      3.1
- */
 public abstract class AbstractCursorHandler implements InvocationHandler {
     
     protected String cursorName;
Index: /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorStatement.java
===================================================================
--- /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorStatement.java	(revision 454206)
+++ /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorStatement.java	(working copy)
@@ -24,11 +24,6 @@
 import org.ofbiz.entity.transaction.GenericTransactionException;
 import org.ofbiz.entity.transaction.TransactionUtil;
 
-/**
- *
- * @version    $Rev$
- * @since      3.1
- */
 public class CursorStatement extends AbstractCursorHandler {
     
     protected ResultSet currentResultSet;
Index: /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorResultSet.java
===================================================================
--- /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorResultSet.java	(revision 454206)
+++ /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorResultSet.java	(working copy)
@@ -20,11 +20,6 @@
 import java.sql.SQLException;
 import java.sql.Statement;
 
-/**
- *
- * @version    $Rev$
- * @since      3.1
- */
 public class CursorResultSet extends AbstractCursorHandler {
 
     protected ResultSet rs;
Index: /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorConnection.java
===================================================================
--- /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorConnection.java	(revision 454206)
+++ /ofbiz/framework/entity/src/org/ofbiz/entity/jdbc/CursorConnection.java	(working copy)
@@ -20,11 +20,6 @@
 import java.sql.PreparedStatement;
 import java.sql.Statement;
 
-/**
- *
- * @version    $Rev$
- * @since      3.1
- */
 public class CursorConnection extends AbstractCursorHandler {
 
     public static Connection newCursorConnection(Connection con, String cursorName, int pageSize) throws Exception {