Index: framework/base/config/ofbiz-containers.xml
===================================================================
--- framework/base/config/ofbiz-containers.xml	(revision 776481)
+++ framework/base/config/ofbiz-containers.xml	(working copy)
@@ -116,7 +116,7 @@
             <property name="access-log-prefix" value="access_log."/>
             <property name="access-log-dir" value="runtime/logs"/>
             <property name="enable-request-dump" value="false"/>
-            <!-- uncomment for cluster support
+            <!-- uncomment for cluster support -->
             <property name="default-server-cluster" value="cluster">
                 <property name="rep-valve-filter">
                     <property-value>.*\.gif;.*\.js;.*\.jpg;.*\.htm;.*\.html;.*\.txt;</property-value>
@@ -121,7 +121,7 @@
                 <property name="rep-valve-filter">
                     <property-value>.*\.gif;.*\.js;.*\.jpg;.*\.htm;.*\.html;.*\.txt;</property-value>
                 </property>
-                <property name="manager-class" value="org.apache.catalina.cluster.session.DeltaManager"/>
+                <property name="manager-class" value="org.apache.catalina.ha.session.DeltaManager"/>
                 <property name="debug" value="5"/>
                 <property name="replication-mode" value="org.apache.catalina.tribes.transport.bio.PooledMultiSender"/>
                 <property name="tcp-listen-host" value="auto"/>
@@ -129,7 +129,7 @@
                 <property name="tcp-sector-timeout" value="100"/>
                 <property name="tcp-thread-count" value="6"/>
                 <property name="mcast-bind-addr" value="192.168.2.1"/>
-                <property name="mcast-addr" value="224.0.0.1"/>
+                <property name="mcast-addr" value="228.0.0.4"/>
                 <property name="mcast-port" value="45564"/>
                 <property name="mcast-freq" value="500"/>
                 <property name="mcast-drop-time" value="3000"/>
@@ -134,7 +134,7 @@
                 <property name="mcast-freq" value="500"/>
                 <property name="mcast-drop-time" value="3000"/>
             </property>
-            -->
+            <!--  -->
             <!-- <property name="ssl-accelerator-port" value="8443"/> -->
             <property name="enable-cross-subdomain-sessions" value="true"/>
         </property>
Index: framework/catalina/src/org/ofbiz/catalina/container/CatalinaContainer.java
===================================================================
--- framework/catalina/src/org/ofbiz/catalina/container/CatalinaContainer.java	(revision 776481)
+++ framework/catalina/src/org/ofbiz/catalina/container/CatalinaContainer.java	(working copy)
@@ -34,6 +34,7 @@
 import org.ofbiz.base.container.Container;
 import org.ofbiz.base.container.ContainerConfig;
 import org.ofbiz.base.container.ContainerException;
+import org.ofbiz.base.container.ContainerConfig.Container.Property;
 import org.ofbiz.base.util.*;
 import org.ofbiz.entity.GenericDelegator;
 
@@ -429,7 +430,15 @@
 
         SimpleTcpCluster cluster = new SimpleTcpCluster();
         cluster.setClusterName(clusterProps.name);
-        cluster.setManagerClassName(mgrClassName);
+        Manager manager = null;
+        try {
+            manager = (Manager)Class.forName(mgrClassName).newInstance();
+        } catch(Exception exc) {
+            throw new ContainerException("Cluster configuration requires a valid manager-class property: " + exc.getMessage());
+        }
+        //cluster.setManagerClassName(mgrClassName);
+        //cluster.registerManager(manager);
+        cluster.setManagerTemplate((org.apache.catalina.ha.ClusterManager)manager);
         //cluster.setDebug(debug);
         // removed since 5.5.9? cluster.setExpireSessionsOnShutdown(expireSession);
         // removed since 5.5.9? cluster.setUseDirtyFlag(useDirty);
@@ -510,7 +519,19 @@
         }
 
         // configure persistent sessions
-        Manager sessionMgr = new StandardManager();
+        Property clusterProp = clusterConfig.get(engine.getName());
+
+        Manager sessionMgr = null;
+        if (clusterProp != null) {
+            String mgrClassName = ContainerConfig.getPropertyValue(clusterProp, "manager-class", "org.apache.catalina.cluster.session.DeltaManager");
+            try {
+                sessionMgr = (Manager)Class.forName(mgrClassName).newInstance();
+            } catch(Exception exc) {
+                throw new ContainerException("Cluster configuration requires a valid manager-class property: " + exc.getMessage());
+            }
+        } else {
+            sessionMgr = new StandardManager();
+        }
 
         // create the web application context
         StandardContext context = (StandardContext) embedded.createContext(mount, location);